%define gitrev 9f03397
%define gitdate 20150930

# How to prepare the source archive from the git tree:
# $ hash=`git log -1 --format='%h'`
# $ date=`git log -1 --format='%cd' --date=short | tr -d -`
# $ git archive --prefix mt7630e-${date}-git${hash}/ ${hash} \
#	| xz -7e > mt7630e-${date}-git${hash}.tar.xz

%define firmware_dir /lib/firmware/

%define _enable_debug_packages	%{nil}
%define debug_package		%{nil}

Summary:	Driver for Mediatek MT7630E Wireless LAN
Name:		mt7630e
Version:	2.3.4
Release:	1.%{gitdate}.2
Source0:	%{name}-%{gitdate}-git%{gitrev}.tar.xz
Source1:	%{name}.rpmlintrc
Source2:	Makefile
License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/benjarobin/MT7630E

Patch1:		0001-Fix-the-description-of-the-module.patch
Patch2:		0002-Specify-the-firmware-for-MT7630E-in-MODULE_FIRMWARE.patch
Patch3:		0003-Use-KERNELRELEASE-to-build-the-modules.patch


%description
This package contains the driver for MT7630E wireless LAN adapter
by Mediatek.


%package -n dkms-%{name}
Summary:	Driver for Mediatek MT7630E Wireless LAN
Group:		System/Kernel and hardware
Requires(post):		dkms
Requires(preun):	dkms


%description -n dkms-%{name}
This package contains the driver for MT7630E wireless LAN adapter
by Mediatek.


%prep
%setup -qn %{name}-%{gitdate}-git%{gitrev}
%apply_patches


%build


%install

# install dkms sources
mkdir -p %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}
cp -R btloader rt2x00 %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/
cp %{SOURCE2} %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/

cat > %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/dkms.conf << EOF
MAKE="make"
PACKAGE_NAME=%{name}
PACKAGE_VERSION=%{version}-%{release}
BUILT_MODULE_NAME[0]=%{name}
BUILT_MODULE_LOCATION[0]="rt2x00/"
BUILT_MODULE_NAME[1]=mt76xx
BUILT_MODULE_LOCATION[1]="btloader/"
DEST_MODULE_LOCATION[0]=/kernel/3rdparty/%{name}
DEST_MODULE_LOCATION[1]=/kernel/3rdparty/%{name}
AUTOINSTALL=yes
EOF

# install the firmware
mkdir -p %{buildroot}%{firmware_dir}
install -m 644 firmware/BT/mt76x0.bin %{buildroot}%{firmware_dir}
install -m 644 firmware/Wi-FI/MT7650E234.bin %{buildroot}%{firmware_dir}


%post -n dkms-%{name}
set -x
/usr/sbin/dkms --rpm_safe_upgrade add -m %{name} -v %{version}-%{release}


# Build and install the driver for all available kernels that have devel
# files, no matter how these kernels were installed (from RPMs or manually).
# Do not fail the installation of the package if the build fails for some
# kernels, this may happen during testing, etc.
for kk in /lib/modules/*; do
	kk=$(echo $kk | sed 's/^\/lib\/modules\///');
	if test -d "/lib/modules/$kk/build"; then
		/usr/sbin/dkms --rpm_safe_upgrade build -m %{name} -v %{version}-%{release} -k $kk &&
		/usr/sbin/dkms --rpm_safe_upgrade install -m %{name} -v %{version}-%{release} -k $kk || true
	else
		echo "WARNING: No development files for kernel \"$kk\"" > /dev/stderr;
	fi;
done


%preun -n dkms-%{name}
# rmmod can fail (e.g. if the module is not loaded), but it should not stop
# deinstallation.
/sbin/rmmod %{name} >/dev/null 2>&1 || true
set -x
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{name} -v %{version}-%{release} --all || true


%files -n dkms-%{name}
%doc LICENSE README.md
%dir %{_usr}/src/%{name}-%{version}-%{release}
%{_usr}/src/%{name}-%{version}-%{release}/*
%{firmware_dir}/MT7650E234.bin
%{firmware_dir}/mt76x0.bin

%changelog

* Tue Jan 05 2016 Evgenii Shatokhin <eugene.shatokhin@rosalab.ru> 2.3.4-1.20150930.2
- (24bcc8c) Release up


